﻿
// MCADoc.h: CMCADoc 类的接口
//


#pragma once

#include <fstream>

class CMCADoc : public CDocument
{
protected: // 仅从序列化创建
	CMCADoc() noexcept;
	DECLARE_DYNCREATE(CMCADoc)

// 特性
public:
	int m_nChannelCount[1024];
	int m_nChannelSmooth[1024];

private:
	// reference spectrum
	double es_Co60[1024] = {};
	double es_Cs137[1024] = {};
	double es_Na22[1024] = {};

// 操作
public:
	void RandomPeak(CString name, int n);
	double Uniform();

// 重写
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

#ifdef SHARED_HANDLERS
	virtual void InitializeSearchContent();
	virtual void OnDrawThumbnail(CDC& dc, LPRECT lprcBounds);
#endif // SHARED_HANDLERS

// 实现
public:
	virtual ~CMCADoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// 生成的消息映射函数
protected:
	DECLARE_MESSAGE_MAP()

#ifdef SHARED_HANDLERS
	// 用于为搜索处理程序设置搜索内容的 Helper 函数
	void SetSearchContent(const CString& value);
#endif // SHARED_HANDLERS
public:
	int GetTotal(int L, int R);
	int GetMax(int L, int R);
	CView* GetView(CRuntimeClass* pClass);
};
